--- old/usr/src/lib/libc/port/regex/regerror.c	Tue Feb 13 07:11:49 2018
+++ new/usr/src/lib/libc/port/regex/regerror.c	Tue Feb 13 07:11:49 2018
@@ -1,5 +1,4 @@
 /*
- * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1992, 1993, 1994 Henry Spencer.
  * Copyright (c) 1992, 1993, 1994
  *	The Regents of the University of California.  All rights reserved.
@@ -32,20 +31,21 @@
  * SUCH DAMAGE.
  */
 
+/*
+ * Copyright 2018 Nexenta Systems, Inc.
+ */
+
 #include "lint.h"
-#include "file64.h"
+
 #include <sys/types.h>
-#include <stdio.h>
-#include <string.h>
+
 #include <limits.h>
-#include <stdlib.h>
 #include <regex.h>
+#include <stdlib.h>
+#include <string.h>
 
-#include "utils.h"
 #include "../gen/_libc_gettext.h"
 
-static const char *regatoi(const regex_t *preg, char *localbuf);
-
 #define	RERR(x, msg)	{ x, #x, msg }
 
 static struct rerr {
@@ -66,24 +66,15 @@
 	RERR(REG_ERANGE,	"invalid character range"),
 	RERR(REG_ESPACE,	"out of memory"),
 	RERR(REG_BADRPT,	"repetition-operator operand invalid"),
-#ifdef	REG_EMPTY
 	RERR(REG_EMPTY,		"empty (sub)expression"),
-#endif
-	RERR(REG_EFATAL,	"fatal internal error"),
-#ifdef	REG_INVARG
 	RERR(REG_INVARG,	"invalid argument to regex routine"),
-#endif
-	RERR(REG_ECHAR,		"illegal byte sequence"),
-	RERR(REG_ENOSYS,	"function not supported"),
-	RERR(REG_STACK,		"backtrack stack overflow"),
-	RERR(REG_ENSUB,		"more than 9 \\( \\) pairs"),
-	RERR(REG_ENEWLINE,	"\n found before end of pattern"),
+	RERR(REG_ILLSEQ,	"illegal byte sequence"),
 	{0,	"",		"*** unknown regexp error code ***"}
 };
 
 
 /*
- * regerror - the interface to error numbers
+ * The interface to error numbers
  */
 /* ARGSUSED */
 size_t
@@ -92,58 +83,24 @@
 {
 	struct rerr *r;
 	size_t len;
-	int target = errcode &~ REG_ITOA;
 	const char *s;
-	char convbuf[50];
 
-	if (errcode == REG_ATOI) {
-		s = regatoi(preg, convbuf);
-	} else {
-		for (r = rerrs; r->code != 0; r++) {
-			if (r->code == target)
-				break;
-		}
-
-		if (errcode&REG_ITOA) {
-			if (r->code != 0)
-				(void) strcpy(convbuf, r->name);
-			else
-				(void) sprintf(convbuf, "REG_0x%x", target);
-			assert(strlen(convbuf) < sizeof (convbuf));
-			s = convbuf;
-		} else {
-			s = _libc_gettext(r->explain);
-		}
+	for (r = rerrs; r->code != 0; r++) {
+		if (r->code == errcode)
+			break;
 	}
 
+	s = _libc_gettext(r->explain);
+
 	len = strlen(s) + 1;
-	if (errbuf_size > 0) {
+	if (errbuf != NULL && errbuf_size > 0) {
 		if (errbuf_size > len) {
 			(void) strcpy(errbuf, s);
 		} else {
-			(void) strncpy(errbuf, s, errbuf_size-1);
-			errbuf[errbuf_size-1] = '\0';
+			(void) strncpy(errbuf, s, errbuf_size - 1);
+			errbuf[errbuf_size - 1] = '\0';
 		}
 	}
 
 	return (len);
-}
-
-/*
- * regatoi - internal routine to implement REG_ATOI
- */
-static const char *
-regatoi(const regex_t *preg, char *localbuf)
-{
-	struct rerr *r;
-
-	for (r = rerrs; r->code != 0; r++) {
-		if (strcmp(r->name, preg->re_endp) == 0)
-			break;
-	}
-	if (r->code == 0)
-		return ("0");
-
-	(void) sprintf(localbuf, "%d", r->code);
-	return (localbuf);
 }
--- old/usr/src/lib/libc/port/regex/regexec.c	Tue Feb 13 07:11:49 2018
+++ new/usr/src/lib/libc/port/regex/regexec.c	Tue Feb 13 07:11:49 2018
@@ -1,225 +1,303 @@
 /*
- * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
- * Copyright (c) 1992, 1993, 1994 Henry Spencer.
- * Copyright (c) 1992, 1993, 1994
- *	The Regents of the University of California.  All rights reserved.
+ * Copyright (c) 2001-2009 Ville Laurikari <vl@iki.fi>
+ * All rights reserved.
  *
- * This code is derived from software contributed to Berkeley by
- * Henry Spencer.
- *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
+ *
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
+ *
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
- * 3. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
  *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
+ * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
 
 /*
- * the outer shell of regexec()
- *
- * This file includes engine.c three times, after muchos fiddling with the
- * macros that code uses.  This lets the same code operate on two different
- * representations for state sets and characters.
- */
-#include "lint.h"
-#include "file64.h"
-#include <sys/types.h>
-#include <stdio.h>
+  tre_regexec.c - TRE POSIX compatible matching functions (and more).
+*/
+
+#include <assert.h>
+#include <limits.h>
 #include <stdlib.h>
 #include <string.h>
-#include <limits.h>
-#include <ctype.h>
-#include <regex.h>
 #include <wchar.h>
 #include <wctype.h>
-#include <note.h>
-#include <assert.h>
 
-#include "utils.h"
-#include "regex2.h"
+#include "tre-internal.h"
+#include "tre-match-utils.h"
+#include "tre.h"
 
-/* we want _NOTE, but not NOTE (which collides with our own use) */
-#undef	NOTE
-
-static size_t
-xmbrtowc(wint_t *wi, const char *s, size_t n, mbstate_t *mbs, wint_t dummy)
+/* For each tre_last_matched_t in the lm array, find the last matched branch by
+   comparing the touch value of the cmp_tag's.  For all other branches, reset
+   the corresponding tags.  If reset_all is non-zero, reset all tags in all
+   branches.  Recurse into the nested last matched structures, clearing tags as
+   apprpriate. */
+static void
+tre_reset_last_matched_branches(tre_tag_t *tags, const tre_last_matched_t *lm,
+			        int n, int start_tag, int reset_all)
 {
-	size_t nr;
-	wchar_t wc;
+  int max, i, reset;
+  tre_last_matched_branch_t *b;
 
-	nr = mbrtowc(&wc, s, n, mbs);
-	if (wi != NULL)
-		*wi = wc;
-	if (nr == 0)
-		return (1);
-	else if (nr == (size_t)-1 || nr == (size_t)-2) {
-		(void) memset(mbs, 0, sizeof (*mbs));
-		if (wi != NULL)
-			*wi = dummy;
-		return (1);
-	} else
-		return (nr);
+  DPRINT(("tre_reset_last_matched_branches: n=%d start_tag=%d reset_all=%d\n",
+	  n, start_tag, reset_all));
+  for (; n-- > 0; lm++)
+    {
+      if (lm->n_branches == 1)
+	{
+	  b = lm->branches;
+	  if (start_tag > 0)
+	    {
+	      DPRINT(("  b->cmp_tag=%d %d <? %d\n", b->cmp_tag,
+		      tre_tag_touch_get(tags, b->cmp_tag),
+		      tre_tag_touch_get(tags, start_tag)));
+	      reset = (reset_all || tre_tag_touch_get(tags, b->cmp_tag) <
+		       tre_tag_touch_get(tags, start_tag));
+	    }
+	  else
+	    reset = 0;
+
+	  if (reset)
+	    {
+	      int *t;
+
+	      for (i = b->n_tags, t = b->tags; i > 0; i--, t++)
+		{
+		  DPRINT(("  Resetting t%d\n", *t));
+		  tre_tag_reset(tags, *t);
+		}
+	    }
+	  if (b->n_last_matched > 0)
+	    tre_reset_last_matched_branches(tags, b->last_matched,
+						b->n_last_matched, 
+						lm->start_tag, reset);
+	}
+      else
+	{
+	  if (!reset_all)
+	    {
+#ifdef TRE_DEBUG
+	      int last;
+#endif /* TRE_DEBUG */
+	      max = 0;
+	      for (i = lm->n_branches, b = lm->branches; i > 0; i--, b++)
+		{
+		  int t = b->cmp_tag;
+		  int touch = tre_tag_touch_get(tags, t);
+		  if (touch > max)
+		    {
+		      max = touch;
+#ifdef TRE_DEBUG
+		      last = t;
+#endif /* TRE_DEBUG */
+		    }
+		}
+	      DPRINT(("  Last touched end tag t%d=%d\n", last, max));
+	    }
+
+	  for (i = lm->n_branches, b = lm->branches; i > 0; i--, b++)
+	    {
+	      reset = (reset_all || tre_tag_touch_get(tags, b->cmp_tag) < max);
+	      if (reset)
+		{
+		  int j;
+		  int *t;
+
+		  for (j = b->n_tags, t = b->tags; j > 0; j--, t++)
+		    {
+		      DPRINT(("  Resetting t%d\n", *t));
+		      tre_tag_reset(tags, *t);
+		    }
+		}
+	      if (b->n_last_matched > 0)
+		tre_reset_last_matched_branches(tags, b->last_matched,
+						b->n_last_matched,
+						lm->start_tag, reset);
+	    }
+	}
+    }
 }
 
-static size_t
-xmbrtowc_dummy(wint_t *wi, const char *s, size_t n, mbstate_t *mbs,
-    wint_t dummy)
+/* Fills the POSIX.2 regmatch_t array according to the TNFA tag and match
+   endpoint values. */
+reg_errcode_t
+tre_fill_pmatch(size_t nmatch, regmatch_t pmatch[], int cflags,
+		const tre_tnfa_t *tnfa, const tre_tag_t *intags, int match_eo)
 {
-	_NOTE(ARGUNUSED(n));
-	_NOTE(ARGUNUSED(mbs));
-	_NOTE(ARGUNUSED(dummy));
+  unsigned int i;
 
-	if (wi != NULL)
-		*wi = (unsigned char)*s;
-	return (1);
-}
+  if (cflags & REG_NOSUB) return REG_OK;
 
-/* macros for manipulating states, small version */
-#define	states	long
-#define	states1	states		/* for later use in regexec() decision */
-#define	CLEAR(v)	((v) = 0)
-#define	SET0(v, n)	((v) &= ~((unsigned long)1 << (n)))
-#define	SET1(v, n)	((v) |= (unsigned long)1 << (n))
-#define	ISSET(v, n)	(((v) & ((unsigned long)1 << (n))) != 0)
-#define	ASSIGN(d, s)	((d) = (s))
-#define	EQ(a, b)	((a) == (b))
-#define	STATEVARS	long dummy	/* dummy version */
-#define	STATESETUP(m, n)	/* nothing */
-#define	STATETEARDOWN(m)	/* nothing */
-#define	SETUP(v)	((v) = 0)
-#define	onestate	long
-#define	INIT(o, n)	((o) = (unsigned long)1 << (n))
-#define	INC(o)	((o) <<= 1)
-#define	ISSTATEIN(v, o)	(((v) & (o)) != 0)
-/* some abbreviations; note that some of these know variable names! */
-/* do "if I'm here, I can also be there" etc without branches */
-#define	FWD(dst, src, n)	((dst) |= ((unsigned long)(src)&(here)) << (n))
-#define	BACK(dst, src, n)	((dst) |= ((unsigned long)(src)&(here)) >> (n))
-#define	ISSETBACK(v, n)	(((v) & ((unsigned long)here >> (n))) != 0)
-/* no multibyte support */
-#define	XMBRTOWC	xmbrtowc_dummy
-#define	ZAPSTATE(mbs)	((void)(mbs))
-/* function names */
-#define	SNAMES			/* engine.c looks after details */
+  i = 0;
+  if (match_eo >= 0 && intags)
+    {
+      const tre_tag_t *tags = intags;
+      tre_submatch_data_t *submatch_data;
 
-#include "engine.c"
+      if (tnfa->last_matched_branch &&
+	  tnfa->last_matched_branch->n_last_matched > 0)
+	{
+	  tre_tag_t *t;
+	  t = malloc(sizeof(*t) * tnfa->num_tags);
+	  if (!t) return REG_ESPACE;
+	  memcpy(t, intags, tnfa->num_tags * sizeof(tre_tag_t));
+	  tre_reset_last_matched_branches(t,
+				    tnfa->last_matched_branch->last_matched,
+				    tnfa->last_matched_branch->n_last_matched,
+				    0, 0);
+	  tags = t;
+	}
+      /* Construct submatch offsets from the tags. */
+      DPRINT(("end tag = t%d = %d\n", tnfa->end_tag, match_eo));
+      submatch_data = tnfa->submatch_data;
+      while (i < tnfa->num_submatches && i < nmatch)
+	{
+	  if (submatch_data[i].so_tag == tnfa->end_tag)
+	    pmatch[i].rm_so = match_eo;
+	  else
+	    pmatch[i].rm_so = tre_tag_get(tags, submatch_data[i].so_tag);
 
-/* now undo things */
-#undef	states
-#undef	CLEAR
-#undef	SET0
-#undef	SET1
-#undef	ISSET
-#undef	ASSIGN
-#undef	EQ
-#undef	STATEVARS
-#undef	STATESETUP
-#undef	STATETEARDOWN
-#undef	SETUP
-#undef	onestate
-#undef	INIT
-#undef	INC
-#undef	ISSTATEIN
-#undef	FWD
-#undef	BACK
-#undef	ISSETBACK
-#undef	SNAMES
-#undef	XMBRTOWC
-#undef	ZAPSTATE
+	  if (submatch_data[i].eo_tag == tnfa->end_tag)
+	    pmatch[i].rm_eo = match_eo;
+	  else
+	    pmatch[i].rm_eo = tre_tag_get(tags, submatch_data[i].eo_tag);
 
-/* macros for manipulating states, large version */
-#define	states	char *
-#define	CLEAR(v)	(void) memset(v, 0, m->g->nstates)
-#define	SET0(v, n)	((v)[n] = 0)
-#define	SET1(v, n)	((v)[n] = 1)
-#define	ISSET(v, n)	((v)[n])
-#define	ASSIGN(d, s)	(void) memcpy(d, s, m->g->nstates)
-#define	EQ(a, b)	(memcmp(a, b, m->g->nstates) == 0)
-#define	STATEVARS	long vn; char *space
-#define	STATESETUP(m, nv) { (m)->space = malloc((nv)*(m)->g->nstates); \
-	if ((m)->space == NULL) \
-		return (REG_ESPACE); \
-	(m)->vn = 0; }
-#define	STATETEARDOWN(m)	{ free((m)->space); }
-#define	SETUP(v)	((v) = &m->space[m->vn++ * m->g->nstates])
-#define	onestate	long
-#define	INIT(o, n)	((o) = (n))
-#define	INC(o)	((o)++)
-#define	ISSTATEIN(v, o)	((v)[o])
-/* some abbreviations; note that some of these know variable names! */
-/* do "if I'm here, I can also be there" etc without branches */
-#define	FWD(dst, src, n)	((dst)[here+(n)] |= (src)[here])
-#define	BACK(dst, src, n)	((dst)[here-(n)] |= (src)[here])
-#define	ISSETBACK(v, n)	((v)[here - (n)])
-/* no multibyte support */
-#define	XMBRTOWC	xmbrtowc_dummy
-#define	ZAPSTATE(mbs)	((void)(mbs))
-/* function names */
-#define	LNAMES			/* flag */
+	  /* If either of the endpoints were not used, this submatch
+	     was not part of the match. */
+	  if (pmatch[i].rm_so == -1 || pmatch[i].rm_eo == -1)
+	    pmatch[i].rm_so = pmatch[i].rm_eo = -1;
 
-#include "engine.c"
+	  DPRINT(("pmatch[%d] = {t%d = %qd, t%d = %qd}\n", i,
+		  submatch_data[i].so_tag, pmatch[i].rm_so,
+		  submatch_data[i].eo_tag, pmatch[i].rm_eo));
+	  i++;
+	}
+	if (tags != intags) free(__DECONST(tre_tag_t *,tags));
+    }
 
-/* multibyte character & large states version */
-#undef	LNAMES
-#undef	XMBRTOWC
-#undef	ZAPSTATE
-#define	XMBRTOWC	xmbrtowc
-#define	ZAPSTATE(mbs)	(void) memset((mbs), 0, sizeof (*(mbs)))
-#define	MNAMES
+  while (i < nmatch)
+    {
+      pmatch[i].rm_so = -1;
+      pmatch[i].rm_eo = -1;
+      i++;
+    }
 
-#include "engine.c"
+  return REG_OK;
+}
 
 /*
- * regexec - interface for matching
- *
- * We put this here so we can exploit knowledge of the state representation
- * when choosing which matcher to call.  Also, by this point the matchers
- * have been prototyped.
- */
-int				/* 0 success, REG_NOMATCH failure */
-regexec(const regex_t *_RESTRICT_KYWD preg, const char *_RESTRICT_KYWD string,
-    size_t nmatch, regmatch_t pmatch[_RESTRICT_KYWD], int eflags)
+  Wrapper functions for POSIX compatible regexp matching.
+*/
+
+int
+tre_have_backrefs(const regex_t *preg)
 {
-	struct re_guts *g = preg->re_g;
-#ifdef REDEBUG
-#define	GOODFLAGS(f)	(f)
+  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;
+  return tnfa->have_backrefs;
+}
+
+static int
+tre_match(const tre_tnfa_t *tnfa, const void *string, size_t len,
+	  tre_str_type_t type, size_t nmatch, regmatch_t pmatch[],
+	  int eflags)
+{
+  reg_errcode_t status;
+  tre_tag_t *tags = NULL;
+  int eo;
+  size_t offset = 0, count = 0;
+  if (tnfa->num_tags > 0 && nmatch > 0)
+    {
+      tags = malloc(sizeof(*tags) * tnfa->num_tags);
+      if (tags == NULL)
+	return REG_ESPACE;
+    }
+
+  if (
+      (eflags & REG_STARTEND) && pmatch)
+    {
+      if (pmatch->rm_so < 0)
+	return REG_INVARG;
+      if (len == (size_t)-1)
+	{
+	  if (pmatch->rm_eo < 0 || pmatch->rm_so > pmatch->rm_eo)
+	    return REG_INVARG;
+	  len = pmatch->rm_eo - pmatch->rm_so;
+	}
+      count = offset = pmatch->rm_so;
+      if (type == STR_WIDE) offset *= sizeof(wchar_t);
+    }
+
+  /* Dispatch to the appropriate matcher. */
+#ifdef REG_BACKTRACKING_MATCHER
+  if (tnfa->have_backrefs || eflags & REG_BACKTRACKING_MATCHER)
 #else
-#ifdef	REG_STARTEND
-#define	GOODFLAGS(f)	((f)&(REG_NOTBOL|REG_NOTEOL|REG_STARTEND))
-#else
-#define	GOODFLAGS(f)	((f)&(REG_NOTBOL|REG_NOTEOL))
+  if (tnfa->have_backrefs)
 #endif
-#endif
+    {
+      /* The regex has back references, use the backtracking matcher. */
+      status = tre_tnfa_run_backtrack(tnfa, string + offset, (int)len, type,
+				      tags, eflags, &eo);
+    }
+  else
+    {
+      /* Exact matching, no back references, use the parallel matcher. */
+      status = tre_tnfa_run_parallel(tnfa, string + offset, (int)len, type,
+				     tags, eflags, &eo);
+    }
 
-	if (preg->re_magic != MAGIC1 || g->magic != MAGIC2)
-		return (REG_BADPAT);
-	assert(!(g->iflags&BAD));
-	if (g->iflags&BAD)		/* backstop for no-debug case */
-		return (REG_BADPAT);
-	eflags = GOODFLAGS(eflags);
+  if (status == REG_OK)
+    {
+      /* A match was found, so fill the submatch registers. */
+      status = tre_fill_pmatch(nmatch, pmatch, tnfa->cflags, tnfa, tags, eo);
+      /* If doing REG_STARTEND, adjust the pmatch array (we can't build
+         this into tre_fill_pmatch, because tre_tnfa_run_backtrack calls
+	 tre_fill_pmatch itself). */
+      if (status == REG_OK && !(tnfa->cflags & REG_NOSUB) &&
+	  (eflags & REG_STARTEND) && pmatch && nmatch > 0)
+	{
+	  size_t i;
+	  regmatch_t *p;
+	  for (i = nmatch, p = pmatch; i > 0; p++, i--)
+	    {
+	      if (p->rm_so >= 0) p->rm_so += count;
+	      if (p->rm_eo >= 0) p->rm_eo += count;
+	    }
+	}
+    }
+  if (tags)
+    free(tags);
+  return status;
+}
 
-	if (MB_CUR_MAX > 1)
-		return (mmatcher(g, string, nmatch, pmatch, eflags));
-	else if (g->nstates <= CHAR_BIT*sizeof (states1) && !(eflags&REG_LARGE))
-		return (smatcher(g, string, nmatch, pmatch, eflags));
-	else
-		return (lmatcher(g, string, nmatch, pmatch, eflags));
+int
+tre_regnexec(const regex_t *preg, const char *str, size_t len,
+	 size_t nmatch, regmatch_t pmatch[], int eflags)
+{
+  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;
+  tre_str_type_t type = (TRE_MB_CUR_MAX_L(tnfa->loc) == 1) ? STR_BYTE : STR_MBS;
+
+  if (preg->re_magic != RE_MAGIC) return REG_BADPAT;
+
+  return tre_match(tnfa, str, len, type, nmatch, pmatch, eflags);
+}
+
+int
+regexec(const regex_t *_RESTRICT_KYWD preg, const char *_RESTRICT_KYWD str,
+    size_t nmatch, regmatch_t pmatch[_RESTRICT_KYWD], int eflags)
+{
+  return tre_regnexec(preg, str, (size_t)-1, nmatch, pmatch, eflags);
 }
--- /dev/null	Tue Feb 13 07:11:50 2018
+++ new/usr/src/lib/libc/port/regex/tre-ast.c	Tue Feb 13 07:11:50 2018
@@ -0,0 +1,245 @@
+/*
+ * Copyright (c) 2001-2009 Ville Laurikari <vl@iki.fi>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
+ * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+  tre-ast.c - Abstract syntax tree (AST) routines
+*/
+
+#include <assert.h>
+
+#include "tre-ast.h"
+#include "tre-mem.h"
+
+tre_ast_node_t *
+tre_ast_new_node(tre_mem_t mem, tre_ast_type_t type, size_t size)
+{
+  tre_ast_node_t *node;
+
+  node = tre_mem_calloc(mem, sizeof(*node));
+  if (!node)
+    return NULL;
+  node->obj = tre_mem_calloc(mem, size);
+  if (!node->obj)
+    return NULL;
+  node->type = type;
+  node->nullable = -1;
+  node->submatch_id = -1;
+
+  return node;
+}
+
+tre_ast_node_t *
+tre_ast_new_literal(tre_mem_t mem, int code_min, int code_max, int position)
+{
+  tre_ast_node_t *node;
+  tre_literal_t *lit;
+
+  node = tre_ast_new_node(mem, LITERAL, sizeof(tre_literal_t));
+  if (!node)
+    return NULL;
+  lit = node->obj;
+  lit->code_min = code_min;
+  lit->code_max = code_max;
+  lit->position = position;
+
+  return node;
+}
+
+tre_ast_node_t *
+tre_ast_new_iter(tre_mem_t mem, tre_ast_node_t *arg, int min, int max,
+		 int minimal)
+{
+  tre_ast_node_t *node;
+  tre_iteration_t *iter;
+
+  node = tre_ast_new_node(mem, ITERATION, sizeof(tre_iteration_t));
+  if (!node)
+    return NULL;
+  iter = node->obj;
+  iter->arg = arg;
+  iter->min = min;
+  iter->max = max;
+  iter->minimal = minimal;
+  node->num_submatches = arg->num_submatches;
+
+  return node;
+}
+
+tre_ast_node_t *
+tre_ast_new_union(tre_mem_t mem, tre_ast_node_t *left, tre_ast_node_t *right)
+{
+  tre_ast_node_t *node;
+
+  node = tre_ast_new_node(mem, UNION, sizeof(tre_union_t));
+  if (node == NULL)
+    return NULL;
+  ((tre_union_t *)node->obj)->left = left;
+  ((tre_union_t *)node->obj)->right = right;
+  node->num_submatches = left->num_submatches + right->num_submatches;
+
+  return node;
+}
+
+tre_ast_node_t *
+tre_ast_new_catenation(tre_mem_t mem, tre_ast_node_t *left,
+		       tre_ast_node_t *right)
+{
+  tre_ast_node_t *node;
+
+  node = tre_ast_new_node(mem, CATENATION, sizeof(tre_catenation_t));
+  if (node == NULL)
+    return NULL;
+  ((tre_catenation_t *)node->obj)->left = left;
+  ((tre_catenation_t *)node->obj)->right = right;
+  node->num_submatches = left->num_submatches + right->num_submatches;
+
+  return node;
+}
+
+#ifdef TRE_DEBUG
+
+static void
+tre_findent(FILE *stream, int i)
+{
+  while (i-- > 0)
+    fputc(' ', stream);
+}
+
+void
+tre_print_params(int *params)
+{
+  int i;
+  if (params)
+    {
+      DPRINT(("params ["));
+      for (i = 0; i < TRE_PARAM_LAST; i++)
+	{
+	  if (params[i] == TRE_PARAM_UNSET)
+	    DPRINT(("unset"));
+	  else if (params[i] == TRE_PARAM_DEFAULT)
+	    DPRINT(("default"));
+	  else
+	    DPRINT(("%d", params[i]));
+	  if (i < TRE_PARAM_LAST - 1)
+	    DPRINT((", "));
+	}
+      DPRINT(("]"));
+    }
+}
+
+static void
+tre_do_print(FILE *stream, tre_ast_node_t *ast, int indent)
+{
+  int code_min, code_max, pos;
+  int num_tags = ast->num_tags;
+  tre_literal_t *lit;
+  tre_iteration_t *iter;
+
+  tre_findent(stream, indent);
+  switch (ast->type)
+    {
+    case LITERAL:
+      lit = ast->obj;
+      code_min = lit->code_min;
+      code_max = lit->code_max;
+      pos = lit->position;
+      if (IS_EMPTY(lit))
+	{
+	  fprintf(stream, "literal empty\n");
+	}
+      else if (IS_ASSERTION(lit))
+	{
+	  int i;
+	  char *assertions[] = { "bol", "eol", "bracket",
+				 "bow", "eow", "wb", "!wb", "backref" };
+	  if (code_max >= ASSERT_LAST << 1)
+	    assert(0);
+	  fprintf(stream, "assertions: ");
+	  for (i = 0; (1 << i) <= ASSERT_LAST; i++)
+	    if (code_max & (1 << i))
+	      fprintf(stream, "%s ", assertions[i]);
+	  fprintf(stream, "\n");
+	}
+      else if (IS_TAG(lit))
+	{
+	  fprintf(stream, "tag %d\n", code_max);
+	}
+      else if (IS_BACKREF(lit))
+	{
+	  fprintf(stream, "backref %d, pos %d\n", code_max, pos);
+	}
+      else if (IS_PARAMETER(lit))
+	{
+	  tre_print_params(lit->u.params);
+	  fprintf(stream, "\n");
+	}
+      else
+	{
+	  fprintf(stream, "literal (%c, %c) (%d, %d), pos %d, sub %d, "
+		  "%d tags\n", code_min, code_max, code_min, code_max, pos,
+		  ast->submatch_id, num_tags);
+	}
+      break;
+    case ITERATION:
+      iter = ast->obj;
+      fprintf(stream, "iteration {%d, %d}, sub %d, %d tags, %s\n",
+	      iter->min, iter->max, ast->submatch_id, num_tags,
+	      iter->minimal ? "minimal" : "greedy");
+      tre_do_print(stream, iter->arg, indent + 2);
+      break;
+    case UNION:
+      fprintf(stream, "union, sub %d, %d tags\n", ast->submatch_id, num_tags);
+      tre_do_print(stream, ((tre_union_t *)ast->obj)->left, indent + 2);
+      tre_do_print(stream, ((tre_union_t *)ast->obj)->right, indent + 2);
+      break;
+    case CATENATION:
+      fprintf(stream, "catenation, sub %d, %d tags\n", ast->submatch_id,
+	      num_tags);
+      tre_do_print(stream, ((tre_catenation_t *)ast->obj)->left, indent + 2);
+      tre_do_print(stream, ((tre_catenation_t *)ast->obj)->right, indent + 2);
+      break;
+    default:
+      assert(0);
+      break;
+    }
+}
+
+static void
+tre_ast_fprint(FILE *stream, tre_ast_node_t *ast)
+{
+  tre_do_print(stream, ast, 0);
+}
+
+void
+tre_ast_print(tre_ast_node_t *tree)
+{
+  printf("AST:\n");
+  tre_ast_fprint(stdout, tree);
+}
+
+#endif /* TRE_DEBUG */
--- /dev/null	Tue Feb 13 07:11:50 2018
+++ new/usr/src/lib/libc/port/regex/tre-ast.h	Tue Feb 13 07:11:50 2018
@@ -0,0 +1,159 @@
+/*
+ * Copyright (c) 2001-2009 Ville Laurikari <vl@iki.fi>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
+ * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+  tre-ast.h - Abstract syntax tree (AST) definitions
+*/
+
+#ifndef	_TRE_AST_H
+#define	_TRE_AST_H
+
+#include <limits.h>
+
+#include "tre-mem.h"
+#include "tre-internal.h"
+#include "tre-compile.h"
+
+/* The different AST node types. */
+typedef enum {
+  LITERAL,
+  CATENATION,
+  ITERATION,
+  UNION
+} tre_ast_type_t;
+
+/* Special subtypes of TRE_LITERAL. */
+#define EMPTY	  -1   /* Empty leaf (denotes empty string). */
+#define ASSERTION -2   /* Assertion leaf. */
+#define TAG	  -3   /* Tag leaf. */
+#define BACKREF	  -4   /* Back reference leaf. */
+#define PARAMETER -5   /* Parameter. */
+
+#define IS_SPECIAL(x)	((x)->code_min < 0)
+#define IS_EMPTY(x)	((x)->code_min == EMPTY)
+#define IS_ASSERTION(x) ((x)->code_min == ASSERTION)
+#define IS_TAG(x)	((x)->code_min == TAG)
+#define IS_BACKREF(x)	((x)->code_min == BACKREF)
+#define IS_PARAMETER(x) ((x)->code_min == PARAMETER)
+
+#define SUBMATCH_ID_INVISIBLE_START	(INT_MAX / 2 + 1)
+
+/* A generic AST node.  All AST nodes consist of this node on the top
+   level with `obj' pointing to the actual content. */
+typedef struct _tre_ast_node {
+  void *obj;             /* Pointer to actual node. */
+  tre_last_matched_branch_pre_t *last_matched_branch;
+  tre_last_matched_pre_t *last_matched_in_progress;
+  tre_pos_and_tags_t *firstpos;
+  tre_pos_and_tags_t *lastpos;
+  /* The original pointer is used to point to the original node, when a
+   * CATENATION and tag are added.  If NULL, this is node is the original */
+  struct _tre_ast_node *original;
+  tre_ast_type_t type;   /* Type of the node. */
+  int submatch_id;
+  int num_submatches;
+  int num_tags;
+  short nullable;
+  short make_branches;
+} tre_ast_node_t;
+
+/* A "literal" node.  These are created for assertions, back references,
+   tags, matching parameter settings, and all expressions that match one
+   character. */
+typedef struct {
+  tre_cint_t code_min;
+  tre_cint_t code_max;
+  int position;
+  union {
+    tre_bracket_match_list_t *bracket_match_list;
+    int *params;
+  } u;
+} tre_literal_t;
+
+/* A "catenation" node.	 These are created when two regexps are concatenated.
+   If there are more than one subexpressions in sequence, the `left' part
+   holds all but the last, and `right' part holds the last subexpression
+   (catenation is left associative). */
+typedef struct {
+  tre_ast_node_t *left;
+  tre_ast_node_t *right;
+} tre_catenation_t;
+
+/* An "iteration" node.	 These are created for the "*", "+", "?", and "{m,n}"
+   operators. */
+typedef struct {
+  /* Subexpression to match. */
+  tre_ast_node_t *arg;
+  /* Minimum number of consecutive matches. */
+  int min;
+  /* Maximum number of consecutive matches. */
+  int max;
+  /* If 0, match as many characters as possible, if 1 match as few as
+     possible.	Note that this does not always mean the same thing as
+     matching as many/few repetitions as possible. */
+  unsigned int minimal:1;
+  /* Approximate matching parameters (or NULL). */
+  int *params;
+} tre_iteration_t;
+
+/* An "union" node.  These are created for the "|" operator. */
+typedef struct {
+  tre_ast_node_t *left;
+  tre_ast_node_t *right;
+  /* The left end right end tags if non-zero */
+  int left_tag;
+  int right_tag;
+} tre_union_t;
+
+tre_ast_node_t *
+tre_ast_new_node(tre_mem_t mem, tre_ast_type_t type, size_t size);
+
+tre_ast_node_t *
+tre_ast_new_literal(tre_mem_t mem, int code_min, int code_max, int position);
+
+tre_ast_node_t *
+tre_ast_new_iter(tre_mem_t mem, tre_ast_node_t *arg, int min, int max,
+		 int minimal);
+
+tre_ast_node_t *
+tre_ast_new_union(tre_mem_t mem, tre_ast_node_t *left, tre_ast_node_t *right);
+
+tre_ast_node_t *
+tre_ast_new_catenation(tre_mem_t mem, tre_ast_node_t *left,
+		       tre_ast_node_t *right);
+
+#ifdef TRE_DEBUG
+void
+tre_ast_print(tre_ast_node_t *tree);
+
+/* XXX - rethink AST printing API */
+void
+tre_print_params(int *params);
+#endif /* TRE_DEBUG */
+
+#endif	/* _TRE_AST_H */
